unit maintest;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Spin;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Label1: TLabel;
    Button6: TButton;
    Panel1: TPanel;
    Button7: TButton;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    ComboBox3: TComboBox;
    ComboBox4: TComboBox;
    Button8: TButton;
    Panel2: TPanel;
    SpinEdit1: TSpinEdit;
    Button9: TButton;
    ComboBox5: TComboBox;
    ComboBox6: TComboBox;
    Button10: TButton;
    Label2: TLabel;
    Button11: TButton;
    Button12: TButton;
    Button13: TButton;
    Label3: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

const
  PINS_HI = 3;
  PINS_LO = 2;
  PINS_HIZ = 1;
  PINS_D_BIT = 0;
  PINS_C_BIT = 2;
  PINS_P_BIT = 4;
  PINS_L_BIT = 6;

  SHIFT_MODE1=$01; //mode value
  SHIFT_MODE3=$03;

var
  Form1: TForm1;

implementation

{$R *.dfm}

Function AGet(var answer: integer): LongBool; stdcall; external 'presto.dll';
Procedure QSetActiveLED(led: LongBool); stdcall; external 'presto.dll';
Procedure QOpenPresto(sn: integer); stdcall; external 'presto.dll';
Procedure QClosePresto; stdcall; external 'presto.dll';
Procedure QPoweronVdd(delayus: integer); stdcall; external 'presto.dll';
Procedure QPoweroffVdd; stdcall; external 'presto.dll';
Function AGetBlocking: integer; stdcall; external 'presto.dll';
Procedure QSetPins(pins: cardinal); stdcall; external 'presto.dll';
Procedure QGetPins; stdcall; external 'presto.dll';
Procedure QShiftByte(databyte:integer; mode:integer); stdcall; external 'presto.dll';
Procedure QShiftByte_OutIn(databyte:integer; mode:integer; InputPin:integer); stdcall; external 'presto.dll';
Procedure QCheckSupplyVoltage; stdcall; external 'presto.dll';
Procedure QPoweronVpp13V; stdcall; external 'presto.dll';
Procedure QPoweroffVpp13V; stdcall; external 'presto.dll';
Procedure QSetDPullup(dpullup_on: LongBool); stdcall; external 'presto.dll';
Procedure QCheckGoButton; stdcall; external 'presto.dll';
Procedure QSetPrestoSpeed(speed:cardinal); stdcall; external 'presto.dll';
Procedure AGetProgList(buf: pIntegerArray; count:integer; var count_returned:integer); stdcall; external 'presto.dll';



procedure TForm1.Button1Click(Sender: TObject); // Open PRESTO
begin
 QOpenPresto(-1);
end;

procedure TForm1.Button2Click(Sender: TObject); // Close PRESTO
begin
 QClosePresto;
end;



procedure TForm1.Button3Click(Sender: TObject);
begin
 QSetActiveLED(true);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
 QPoweronVdd(10000); //power on VDD and check the over current after 10ms
end;

procedure TForm1.Button5Click(Sender: TObject);
var value:integer;
begin
 if AGet(value) then
  Label1.Caption:='Returned value: '+IntToHex(value,4)
 else
  Label1.Caption:='Returned value: ';

end;

procedure TForm1.Button6Click(Sender: TObject);
begin
 QPoweroffVdd;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
 QSetPins((ComboBox1.ItemIndex+1)shl PINS_D_BIT or (ComboBox2.ItemIndex+1)shl PINS_C_BIT or (ComboBox3.ItemIndex+1)shl PINS_P_BIT or (ComboBox4.ItemIndex+1)shl PINS_L_BIT);
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
 QGetPins;
end;

procedure TForm1.Button9Click(Sender: TObject);
begin
 if ComboBox5.ItemIndex=0 then //mode 1
  QShiftByte(SpinEdit1.Value and $FF, SHIFT_MODE1)
 else
  QShiftByte(SpinEdit1.Value and $FF, SHIFT_MODE3);
end;

procedure TForm1.Button10Click(Sender: TObject);
begin
 if ComboBox5.ItemIndex=0 then //mode 1
  QShiftByte_OutIn(SpinEdit1.Value and $FF, SHIFT_MODE1, ComboBox6.ItemIndex)
 else
  QShiftByte_OutIn(SpinEdit1.Value and $FF, SHIFT_MODE3, ComboBox6.ItemIndex);
end;

procedure TForm1.Button11Click(Sender: TObject);
begin
 QCheckGoButton;
end;

procedure TForm1.Button12Click(Sender: TObject);
begin
 QCheckSupplyVoltage;
end;

procedure TForm1.Button13Click(Sender: TObject);
 var
 i:integer;
 PBuffer:PIntegerArray;
 progs: array [0..5] of cardinal;
 count:integer;
begin
 PBuffer:=@progs;
 AGetProgList(PBuffer,6,count);

 Label3.Caption:=IntToStr(count);

 if count>0 then
  for i := 0 to count-1 do
   Label3.Caption:=Label3.Caption+', '+IntToHex(progs[i],6);
end;

end.
